rm(list=ls())
library(XML)
library(msbase)
library(gstat)
library(mscalib)
library(msmascot)

Sacc <- 0.05
Sig1 <- 65
Sig2 <- 66

DB <- c("NCBIMUSMUS","PIRULLELA","ARABI")
DB <- DB[1]

if(TRUE)
  {
    plat<-"z:"
    plat<-"/home/arabidopsis/ewolski"
    fpD <- "/DATA/mouse/"
    fpP <- "/DATA/mouse/"
                                        #folderD <- "20031010u_dt_mouse_b1"
                                        #folderPPG <- "20031010u_dt_mouse_b1_ppg"
                                        folderD <- "20031010u_dt_mouse_b1_rec"
                                        folderPPG <- "20031010u_dt_mouse_b1_rec_ppg"
                                        #folderD <- "20031016u_dt_mouse_a1_1" #3
                                        #folderPPG <- "20031016u_dt_mouse_a1_1_ppg"
                                        #folderD <- "20031021u_dt_mouse_a1_1rec" #4
                                        #folderPPG <- "20031021u_dt_mouse_a1_1rec_ppg"
   #  folderD <- "20031107u_jg_a1" #6
   # folderPPG <- "20031107u_jg_a1_ppg"
  }


NPPG <- readBruker( new("Massvectorlist") , paste(plat,fpP,folderPPG,sep="") )
object <- readBruker( new("Massvectorlist") , paste(plat,fpD,folderD,sep="") )
print(length(object))

                                        #
                                        #Cheat. 
                                        #

res <- gamasses(object,accur=0.6,abund=length(object)/3)
all <- new("Massvector",matrix(c(1046.5423 ,1296.6853 ,1362.7356,1446.7494,1672.9175,2093.0867,2465.1989,3147.4715),ncol=1),info="kdk")
filt <- finterS(all,res,error=0.4,ppm=F)
object<-fsetdiff(object , filt , error=400 , ppm=T)


##
##Remove higher order error.
##
data(cal2,package="mscalib")

extcalib <- getextcalib(NPPG,ppm=F,error=0.5)
plot(extcalib)
data.precalib <- applycalib(object,extcalib)


res <- gamasses(object,accur=0.6,abund=length(object)/10)
res2 <- gamasses(data.precalib,accur=0.6,abund=length(object)/10)

par(mfrow=c(1,2))
par(mar=c(3,3,1,1))

plot(res,cal2)
plot(res2,cal2)



##
## First Peprolecalibration
##

pep <- getpepcalib(object,mrange=c(20,1300))
pep <- subset(pep , Coeff.Slope > -8*1e-4 & Coeff.Slope < 8*1e-4 )
pep <- subset(pep , Coeff.Intercept > -0.4 & Coeff.Intercept < 0.4 )
cat(length(pep))
data.precalib <- applycalib(object,pep)

##
## 
##

pep <- getpepcalib( data.precalib , mrange=c(20,2500))
pep <- subset(pep , Coeff.Slope > -8*1e-4 & Coeff.Slope < 8*1e-4 )
pep <- subset(pep , Coeff.Intercept > -0.4 & Coeff.Intercept < 0.4 )
cat(length(pep))
data.calib <- applycalib(data.precalib,pep)


##FILTERING OF Abundant masses

abmasses <- gamasses(data.calib,accur=0.2,abund=length(object)/13)


searchconfig <- getSearchconfig()
searchconfig$"DB"=DB
searchconfig$"TOL" = Sacc
searchconfig$"TOLU" <- "Da"
#search the abundant masses
res <- mascotSearch(abmasses , searchconfig,hits=5,minscore=60,research=TRUE,host="fugu")
summary(res)
tmp <- as.data.frame(res)
if(subset(tmp, research==1 & hitid==1)$score > 60)
{
  tmp <- getMatchedMass( res[[as.numeric(rownames(subset(tmp, research==1 & hitid==1)))]] )
  plot(tmp)
  abmasses <- fsetdiff(abmasses,tmp)
}


data.cfilter <- fsetdiff(data.calib,abmasses,error=0.15,ppm=F)

hist(data.calib,accur=0.3)
hist(data.cfilter,col=3,add=T,accur=0.3)


searchconfig$"DB"=DB
searchconfig$"TOL"=Sacc
searchconfig$"TOLU" <- "Da"
searchres <- mascotSearch(data.cfilter,searchconfig,hits=5,minscore=55,research=TRUE,host="fugu")
save(searchres,file=paste(folderD,Sacc,"LRPR.rda",sep=""))

load(file=paste(folderD,Sacc,"LRPR.rda",sep=""))
summary(searchres,sigscore=Sig1)
summary(searchres,sigscore=Sig2)
tmp <- as.data.frame(searchres)
tmp <- subset(tmp, research==1 & hitid==1)$score

hist(tmp,breaks=seq(0,max(tmp)+1,by=1))
abline(v=65,col=2)
